/*

            Monthly log index

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "database.h"
#include "memdb.h"
#include "htmlout.h"

/*  calendarHTML  --  Make a calendar-style HTML index to all
                      months in the memory database.  */

int calendarHTML(char *filename)
{
    int i, j, k, mindex, linked, ok = 0, lyear = -1;
    FILE *fo = fopen(filename, "w");
    struct hdMonth *m;

    if (fo != NULL) {

        fprintf(fo,"\
%s\n\
<title>Eat Watch Log Index</title>\n\
<meta name=\"author\" content=\"Eat Watch Report Generator\">\n\
</head>\n\
<body bgcolor=\"#FFFFFF\">\n\
<center>\n\
<h1>%s Monthly Log Index</h1>\n\
<p>\n\
<hr>\n\
",
            htmlPrefix,
            htmlTitle
        );

        for (i = 0; (m = mdIndexMonth(i)) != NULL; i++) {

            /*  This is the first month we've seen in this
                year.  Generate the table header for the
                calendar for this year.  */

            lyear = m->year;
            fprintf(fo, "\
<a name=\"%d\">&nbsp;</a><br>\n\
<table border cellpadding=5 bgcolor=\"#D0D0D0\">\n\
<tr><td colspan=3 bgcolor=\"#D0D0FF\" align=center><font size=\"7\">%d</font>\n\
",
                m->year,
                m->year
            );

            /*  Emit the cells for the calendar, linking
                to those for which we have database entries.  */

            mindex = 0;
            for (j = 0; j < 4; j++) {
                /*  Start a new row each quarter.  */
                fprintf(fo, "\
<tr>\n\
"               );
                for (k = 0; k < 3; k++) {
                    fprintf(fo, "\
<td align=center width=\"33%%\">\n\
"                   );
                    linked = (m != NULL) &&
                             (lyear == m->year) && (mindex == m->month);
                    if (linked) {
                        fprintf(fo, "\
<a href=\"%04d-%02d.html\">\
",                          m->year, m->month + 1);
                    }
                    fprintf(fo, "%s", months[mindex]);
                    if (linked) {
                        fprintf(fo, "\
</a>\n\
"                       );
                        i++;
                        m = mdIndexMonth(i);
                    } else {
                        fprintf(fo, "\
\n\
"                       );
                    }
                    mindex++;
                }
            }
            fprintf(fo, "\
</table>\n\
"           );

            if (m != NULL) {
                fprintf(fo, "\
<p>\n\
"               );
                i--;
            }
        }

        fprintf(fo,"\
</center>\n\
%s\n\
</body>\n\
</html>\n\
",
            htmlSuffix
        );
        fclose(fo);
        ok = 1;
    }

    return ok;
}
